QT += core gui opengl
greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

TARGET = marsGUI
TEMPLATE = app

QMAKE_CXXFLAGS += -std=c++11 -Wall -Wextra -Wno-unused-parameter -Wno-return-type
QMAKE_CXXFLAGS += -Wno-deprecated

INCLUDEPATH += $$PWD/MarsLib
LIBS += -L$$PWD/MarsLib -lmarsGUI

SOURCES += \
    MarsLib/mpi-O.cpp \
    src/user.cpp \
    src/lib/gaussianDistributionUD.cpp \
    src/lib/eig3UD.cpp \
    src/lib/doublearrayUD.cpp \
    src/lib/intarrayUD.cpp \
    src/lib/fftManagerUD.cpp \
    src/lib/myErrorUD.cpp \
    src/lib/mathStringEvaluationUD.cpp \
#
    src/sm/concretedpm2statusUD.cpp \
    src/sm/concretedpm2UD.cpp \
    src/sm/crackbandUD.cpp \
    src/sm/microplanem4UD.cpp \
    src/sm/microplanem7UD.cpp \
    src/sm/microplanematerialUD.cpp \
    src/sm/plasticpsUD.cpp \
    src/sm/rebarConcBondUD.cpp \
    src/sm/rebarconcretebondUD.cpp \
    src/sm/steelrelaxationUD.cpp \
    src/sm/elasticUD.cpp \
    src/sm/rebarConcBondCorrUD.cpp \
    src/sm/stressstrainUD.cpp \
    src/sm/strainvectorUD.cpp \
    src/sm/stressvectorUD.cpp \
    src/sm/microplanem4ViscoUD.cpp \
#
    src/mldpm/agingModuleUD.cpp \
    src/mldpm/asrEvolutionModelUD.cpp \
    src/mldpm/asrModuleUD.cpp \
    src/mldpm/ldpmModuleListUD.cpp \
    src/mldpm/mtLdpmDifUD.cpp \
    src/mldpm/shrinkageModuleUD.cpp \
    src/mldpm/sm2interpolatorUD.cpp \
    src/mldpm/thermalStrainsModuleUD.cpp \
    src/mldpm/ttL_LdpmDifUD.cpp \
    src/mldpm/mtMLdpmUD.cpp \
    src/mldpm/DashPotModuleUD.cpp \
    src/mldpm/KelvinModuleUD.cpp \
    src/mldpm/spatVarFieldModuleUD.cpp \
    src/mldpm/agingLdpm1UD.cpp \
    src/mldpm/agingLdpm2UD.cpp \
    src/mldpm/ldpmModelGeneratorUD.cpp \
    src/mldpm/creepModuleUD.cpp \
    src/mldpm/creepKelvinUD.cpp \
    src/mldpm/mpsUD.cpp \
    src/mldpm/creepMPSUD.cpp \
    src/mldpm/PorePressureModuleUD.cpp \
    src/mldpm/mtLdpmRockUD.cpp \
#
    src/mldpm/shale/ldpmX.cpp \
    src/mldpm/shale/linkFaceXX.cpp \
    src/mldpm/shale/mtLdpmSh.cpp \
#
    src/mfem/mfemUD.cpp \
    src/mfem/mfemAgingUD.cpp \
    src/mfem/mfemAgingElastUD.cpp \
    src/mfem/mfemAgingCodesUD.cpp \
    src/mfem/mfemMaterialsUD.cpp \
    src/mfem/mfemMatElastUD.cpp \
    src/mfem/mfemModuleListUD.cpp \
    src/mfem/mfemCreepUD.cpp \
    src/mfem/mfemFieldsUD.cpp \
    src/mfem/mfemShrinkageUD.cpp \
    src/mfem/mfemThermalUD.cpp \
    src/mfem/mfemSpatVarFieldUD.cpp \
#
    src/mp/diffMaterialsUD.cpp \
    src/mp/diffUD.cpp \
    src/mp/spatVarGridUD.cpp \
    src/mp/rfInterfaceUD.cpp \
    src/mp/dirFieldUD.cpp \
    src/mp/combinedFieldUD.cpp \
    src/mp/uncorrelatedFieldUD.cpp \
    src/mp/psfUD.cpp \
    src/mp/svfDistributionTypeUD.cpp \
    src/mp/kelvinChainUD.cpp \
    src/mp/dcsUD.cpp \
    src/mp/dcsMpsUD.cpp \
    src/mp/maxwellChainUD.cpp \
    src/mp/rheoChainUD.cpp \
#
    src/misc/fncLstUD.cpp \
    src/misc/nodeSelectionUD.cpp \
    src/misc/pidcontrollerUD.cpp \
    src/misc/gaugeUD.cpp \
    src/misc/coordinateSystemUD.cpp \
    src/misc/mappedCoordinatesUD.cpp \



HEADERS += \
    MarsLib/mars.h \
    src/lib/fftManagerUD.h \
    src/lib/constantsUD.h \
    src/lib/eig3UD.h \
    src/lib/doublearrayUD.h \
    src/lib/intarrayUD.h \
    src/lib/mathFunUD.h \
    src/lib/myErrorUD.h \
    src/lib/vectorManagerUD.h \
    src/lib/gaussianDistributionUD.h \
    src/lib/mathStringEvaluationUD.h \
#
    src/sm/concretedpm2statusUD.h \
    src/sm/concretedpm2UD.h \
    src/sm/concretedpm2variableUD.h \
    src/sm/crackbandUD.h \
    src/sm/microplanem4UD.h \
    src/sm/microplanem7UD.h \
    src/sm/microplanematerialUD.h \
    src/sm/plasticpsUD.h \
    src/sm/rebarConcBondUD.h \
    src/sm/rebarconcretebondUD.h \
    src/sm/steelrelaxationUD.h \
    src/sm/stressstrainUD.h \
    src/sm/strainvectorUD.h \
    src/sm/stressvectorUD.h \
    src/sm/elasticUD.h \
    src/sm/rebarConcBondCorrUD.h \
    src/sm/microplanem4ViscoUD.h \
#
    src/mldpm/agingModuleUD.h \
    src/mldpm/asrEvolutionModelUD.h \
    src/mldpm/asrModuleUD.h \
    src/mldpm/ldpmModuleListUD.h \
    src/mldpm/mtLdpmDifUD.h \
    src/mldpm/shrinkageModuleUD.h \
    src/mldpm/sm2interpolatorUD.h \
    src/mldpm/thermalStrainsModuleUD.h \
    src/mldpm/ttL_LdpmDifUD.h \
    src/mldpm/mtMLdpmUD.h \
    src/mldpm/DashPotModuleUD.h \
    src/mldpm/KelvinModuleUD.h \
    src/mldpm/agingLdpm1UD.h \
    src/mldpm/agingLdpm2UD.h \
    src/mldpm/spatVarFieldModuleUD.h \
    src/mldpm/ldpmModelGeneratorUD.h \
    src/mldpm/creepModuleUD.h \
    src/mldpm/creepKelvinUD.h \
    src/mldpm/mpsUD.h \
    src/mldpm/creepMPSUD.h \
    src/mldpm/PorePressureModuleUD.h \
#
    src/mldpm/shale/ldpmX.h \
    src/mldpm/shale/linkFaceXX.h \
    src/mldpm/shale/mtLdpmSh.h \
#
    src/mfem/mfemUD.h \
    src/mfem/mfemAgingUD.h \
    src/mfem/mfemAgingElastUD.h \
    src/mfem/mfemAgingCodesUD.h \
    src/mfem/mfemMaterialsUD.h \
    src/mfem/mfemMatElastUD.h \
    src/mfem/mfemModuleListUD.h \
    src/mfem/mfemCreepUD.h \
    src/mfem/mfemFieldsUD.h \
    src/mfem/mfemShrinkageUD.h \
    src/mfem/mfemThermalUD.h \
    src/mfem/mfemSpatVarFieldUD.h \
#
    src/mp/diffMaterialsUD.h \
    src/mp/diffUD.h \
    src/mp/spatVarGridUD.h \
    src/mp/rfInterfaceUD.h \
    src/mp/dirFieldUD.h \
    src/mp/combinedFieldUD.h \
    src/mp/uncorrelatedFieldUD.h \
    src/mp/psfUD.h \
    src/mp/dcsUD.h \
    src/mp/dcsMpsUD.h \
    src/mp/maxwellChainUD.h \
    src/mp/rheoChainUD.h \
    src/mp/kelvinChainUD.h \
    src/mp/svfDistributionTypeUD.h \
#
    src/misc/fncLstUD.h \
    src/misc/nodeSelectionUD.h \
    src/misc/pidcontrollerUD.h \
    src/misc/gaugeUD.h \
    src/misc/coordinateSystemUD.h \
    src/misc/mappedCoordinatesUD.h \

PRE_TARGETDEPS += $$PWD/MarsLib/libmarsGUI.a

INCLUDEPATH += $$PWD/MarsLib
DEPENDPATH += $$PWD/

win32 {
    RC_FILE = MARS.rc
}

win32 {
    DEFINES += BUILDDATE=\\\"$$system('echo %date:~6,4%%date:~0,2%%date:~3,2%')\\\"
}
linux {
    DEFINES += BUILDDATE=\\\"$$system(date '+%Y%m%d')\\\"
    INCLUDEPATH += 3rdparty/linux/include
    LIBS += -L$$PWD/3rdparty/linux/lib -lpng -lz
}

macx {
    DEFINES += BUILDDATE=\\\"$$system(date '+%Y%m%d')\\\"
    INCLUDEPATH += 3rdparty/mac/include
    LIBS += -L$$PWD/3rdparty/mac/lib -lpng -lz

    ICON = $$PWD/MarsLib/mars.icns
    copydata.commands = $(COPY_DIR) \
                        $$PWD/MarsLib/mars.icns \
                        $$PWD/MarsLib/mars.rcc \
                        $$OUT_PWD/$$TARGET".app/Contents/Resources"
    first.depends = $(first) copydata
    export(first.depends)
    export(copydata.commands)
    QMAKE_EXTRA_TARGETS += first copydata

    BUNDLEID = <com.ES3inc.MARS>
    QMAKE_TARGET_BUNDLE_PREFIX = com.ES3inc
}
